event add <<paste>> <Button-2>
bind BeforeEvent <<paste>> { richtext::Paste [focus] ; break }

bind SysBefore <Control-Shift-Return>  {
          eval %W tag remove sel 1.0 end
          set xml        [richtext::widgetData %W get xml]
          set xml_node   [richtext::Cursor %W get TAG]
          set xml_type   [simxml::nodeInfo $xml $xml_node type]
          if { $xml_type == "TEXT" } {
            set xml_node [simxml::nodeInfo $xml $xml_node parent]
            set xml_type [simxml::nodeInfo $xml $xml_node type]
          } ;# if

          set xml_parent [simxml::nodeInfo $xml $xml_node parent]
          set xml_name   [simxml::nodeInfo $xml $xml_node name]

          if { [set xml_node_new [simxml::add $xml $xml_parent $xml_name -position [list before $xml_node]]] != -1 } {
            #richtext::updateWidget %W $xml_parent
            # FAST update
            array set style [simcss::getStyle [richtext::widgetData %W get css] $xml_node_new -xml $xml]
            # BUG !!!! Pri bol'shom xml_parent budut tormoza. Luchshe vesti spisok node
            #          s nuznym list-item i tegi iz nego obnovlyat'.
            if { $style(display) == "list-item" } {
              richtext::updateWidget %W $xml_parent
            } else {
              richtext::updateWidget %W $xml_parent
              #richtext::updateWidget %W $xml_node_new
            } ;# if LIST-ITEM
            richtext::Cursor %W set "[lindex [richtext::tagIndex %W $xml_node_new -type empty] 0] + 1 chars"
            %W see insert
          }

          richtext::eventAfter %W <<CursorMove>> %%A %A %%W %W %%K %K
          richtext::widgetData %W set textModify 1

          gui::TreeExpressFill $xml_node_new
          break
}

bind SysBefore <Control-Return>  {
          eval %W tag remove sel 1.0 end
          set xml        [richtext::widgetData %W get xml]
          set xml_node   [richtext::Cursor %W get TAG]
          set xml_type   [simxml::nodeInfo $xml $xml_node type]
          if { $xml_type == "TEXT" } {
            set xml_node [simxml::nodeInfo $xml $xml_node parent]
            set xml_type [simxml::nodeInfo $xml $xml_node type]
          } ;# if

          set xml_parent [simxml::nodeInfo $xml $xml_node parent]
          set xml_name   [simxml::nodeInfo $xml $xml_node name]

          if { [set xml_node_new [simxml::add $xml $xml_parent $xml_name -position [list after $xml_node]]] != -1 } {
            #richtext::updateWidget %W $xml_parent
            # FAST update
            array set style [simcss::getStyle [richtext::widgetData %W get css] $xml_node_new -xml $xml]
            # BUG !!!! Pri bol'shom xml_parent budut tormoza. Luchshe vesti spisok node
            #          s nuznym list-item i tegi iz nego obnovlyat'.
            if { $style(display) == "list-item" } {
              richtext::updateWidget %W $xml_parent
            } else {
              richtext::updateWidget %W $xml_node_new
            } ;# if LIST-ITEM
            richtext::Cursor %W set "[lindex [richtext::tagIndex %W $xml_node_new -type empty] 0] + 1 chars"
            %W see insert
          }

          richtext::eventAfter %W <<CursorMove>> %%A %A %%W %W %%K %K
          richtext::widgetData %W set textModify 1
          
          gui::TreeExpressFill $xml_node_new
          break
        }


# set bindings tag for widget
bindtags $widget [list . BeforeEvent SysBefore Text SysAfter $widget]

bind SysBefore <Home>  {
          eval %W tag remove sel 1.0 end
          foreach { x y width height baseline } [%W dlineinfo [richtext::Cursor %W get]] { break }
          richtext::Cursor %W set @0,$y -no-event
          %W see insert
          richtext::eventAfter  %W <<CursorMove>> %%A %A %%W %W %%K %K
          break
        }
bind SysBefore <Control-Home>  {
          eval %W tag remove sel 1.0 end
          richtext::Cursor %W set 1.0 -no-event
          %W see insert
          richtext::eventAfter  %W <<CursorMove>> %%A %A %%W %W %%K %K
          break
        }
bind SysBefore <End>  {
          eval %W tag remove sel 1.0 end
          foreach { x y width height baseline } [%W dlineinfo [richtext::Cursor %W get]] { break }
          richtext::Cursor %W set @[expr $width + $x],$y -no-event
          %W see insert
          richtext::eventAfter  %W <<CursorMove>> %%A %A %%W %W %%K %K
          break
        }
bind SysBefore <Control-End>  {
          eval %W tag remove sel 1.0 end
          richtext::Cursor %W set end -no-event
          %W see insert
          richtext::eventAfter  %W <<CursorMove>> %%A %A %%W %W %%K %K
          break
        }

bind SysBefore <Key-Down>  {
     eval %W tag remove sel 1.0 end
     set width [ set height [ set x [ set y 0] ] ]
     foreach { x y width height baseline } [%W dlineinfo [richtext::Cursor %W get]] { break }
     set y [expr $y + $height + 5];  set x [expr $x + ($width / 2)]
     richtext::Cursor %W set @$x,$y -no-event
     %W see insert
     %W mark set anchor insert

     richtext::eventAfter  %W <<CursorMove>> %%A %A %%W %W %%K %K
     break
} ;# BIND

bind SysBefore <Shift-Key-Down>  {
     if { [llength [%W tag ranges sel]] == 0 } { %W mark set anchor insert }
     eval %W tag remove sel 1.0 end
     foreach { x y width height baseline } [%W dlineinfo [richtext::Cursor %W get]] { break }
     set y [expr $y + $height];  set x [expr $x + ($width / 2)]
     richtext::Cursor %W set @$x,$y -no-event
     %W see insert
     if { [%W compare anchor < insert] } {
       %W tag add sel anchor insert
     } else {
       %W tag add sel insert anchor
     } ;# if
     richtext::eventAfter  %W <<CursorMove>> %%A %A %%W %W %%K %K
     break
} ;# <Shift-Key-Down>

bind SysBefore <Key-Up>  {
     if { [llength [%W tag ranges sel]] == 0 } { %W mark set anchor insert }
     eval %W tag remove sel 1.0 end
     foreach { x y width height baseline } [%W dlineinfo [richtext::Cursor %W get]] { break }
     set y [expr $y - $height] ; set x [expr $x + ($width / 2)]
     if { $y < 0 } {
       %W yview scroll -1 units
       set y [expr $y + $height]
     } ;# if
     richtext::Cursor %W set @$x,$y -no-event
     %W see insert
     %W mark set anchor insert
     richtext::eventAfter  %W <<CursorMove>> %%A %A %%W %W %%K %K
     break
} ;# <Key-Up>

bind SysBefore <Shift-Key-Up>  {
     eval %W tag remove sel 1.0 end
     foreach { x y width height baseline } [%W dlineinfo [richtext::Cursor %W get]] { break }
     set y [expr $y - $height]  ;  set x [expr $x + ($width / 2)]
     if { $y < 0 } {  %W yview scroll -1 units  ;  set y [expr $y + $height]  } ;# if
     richtext::Cursor %W set @$x,$y -no-event
     %W see insert
     if { [%W compare anchor < insert] } {
              %W tag add sel anchor insert
     } else { %W tag add sel insert anchor } ;# if
     richtext::eventAfter  %W <<CursorMove>> %%A %A %%W %W %%K %K
     break
}


bind SysBefore <<CursorMove>> {+

  if { [string equal [richtext::widgetData %W get xml] {}] } { break }
}


event add <<TextChange>> <Any-Key>
# <<TextChange>> --- Check if we can add symbol in this place
bind SysBefore <KeyPress> {

  if { [string equal [richtext::widgetData %W get xml] {}] } { break }


      set selection  [%W tag ranges sel]
      set cursor     [richtext::Cursor %W get]

      if { ([llength $selection] != 0) && ("%A" != "{}") } {
        if { [catch { richtext::textDelete %W [lindex $selection 0] [lindex $selection 1] } error] } {
          gui::msgDebug "ERROR: errorcode: $errorCode\n$errorInfo"
          break
        } ;# catch eval textDelete for selection
      } ;# if text selection

      switch -- %K {
        BackSpace {
          if { [%W compare $cursor == [lindex [richtext::previousTag %W $cursor] 0]] } {
            break
          } ;# if
        }
        Delete {
          if { [%W compare $cursor == [lindex [richtext::nextTag %W $cursor] 0]] } {
            break
          } ;# if
        }
      } ;# switch

      # Have current text TAG?
      if  { ! [string equal %A {}] } {
        set cur_tag [richtext::previousTag %W insert]
        switch -- [lindex $cur_tag 2] {
          close  -
          open   { break }
          text   { continue }
          empty  {
            set cur_insert [%W index [lindex $cur_tag 0]]
            set next_tag [richtext::nextTag %W [lindex $cur_tag 0]]
            if { [string equal $next_tag {}] } { set next_tag end }
            %W tag delete [lindex $cur_tag 1]:empty
            %W delete [lindex $cur_tag 0] [lindex $next_tag 0]
            set xml [richtext::widgetData %W get xml]
            set xml_node [simxml::add $xml [lindex $cur_tag 1] {} -text "%A" -type TEXT]
            richtext::updateWidget %W [lindex $cur_tag 1]
            richtext::Cursor %W set "$cur_insert + 1 chars"
            richtext::eventAfter  %W <<CursorMove>> %%A %A %%W %W %%K %K
            break
          }
        } ;# switch
      } ;# if Inserted symbol is visible

    } ;# BIND <<TextChange>>


bind SysAfter <KeyPress> {
# BackSpace Delete
# <<TextChange>> --- Update XML Tree data
      if { [string equal %A {}] } {
        continue
      } ;# if
      set cursor     [richtext::Cursor %W get]
      set cur_tag [richtext::previousTag %W insert]
      switch -- [lindex $cur_tag 2] {
        close  -
        open   { break }
        empty  -
        text   {
          set next_tag [richtext::nextTag %W [lindex $cur_tag 0]]
          if { [string equal $next_tag {}] } { set next_tag end }

          simxml::setParam [richtext::widgetData %W get xml] [lindex $cur_tag 1] \
                           -text [%W get [lindex $cur_tag 0] [lindex $next_tag 0]]
          # BUG!!!!!!! zestko zavyazan na imeni text TAG pri izmenenii
          #            algoritma budut problemy.
          %W tag add [lindex $cur_tag 1]:text [lindex $cur_tag 0] [lindex $next_tag 0]
        }
      } ;# switch


      richtext::widgetData %W set textModify 1
} ;# BIND after TextChange

event add <<CursorMove>> <Button-1> <Button-2> <Button-3>


# This BIND run before Text event (ie. Insert, Delete)
bind BeforeEvent <<TextChange>> {
     if { "%A" != "{}" } {
       richtext::eventBefore %W <<TextChange>> %%A %A %%W %W %%K %K
     } ;# if (only visible symbol)
       richtext::eventBefore %W <<CursorMove>> %%A %A %%W %W %%K %K
     }
bind BeforeEvent <<CursorMove>> {
     richtext::eventBefore %W <<CursorMove>> %%A %A %%W %W %%K %K
     }

bind $widget <<TextChange>> {
     if { "%A" != "{}" } {
       richtext::eventAfter  %W <<TextChange>> %%A %A %%W %W %%K %K
     } ;# if (only visible symbol)
       richtext::eventAfter  %W <<CursorMove>> %%A %A %%W %W %%K %K
     }

bind $widget <<CursorMove>>  { \
     richtext::eventAfter  %W <<CursorMove>> %%A %A %%W %W ;\
     }



