package provide tmp 1.0

namespace eval tmp {
  variable VAR    ;  array set VAR {}
  namespace export -clear tset texists tunset

  proc tset { var args } {
    variable VAR
    if { [llength $args] > 0 } {
      set VAR($var) [lindex $args 0]
      return $VAR($var)
    } else {
      if [info exists VAR($var)] {
        return $VAR($var)
      } else {
        return -code error
      } ;# if-else
    } ;# if-else
  } ;# proc SET

  proc texists { var } {
    variable VAR
    return [info exists VAR($var)]
  } ;# proc EXISTS

  proc tunset { args } {
    variable VAR
    foreach { var } $args {  catch { unset VAR($var) }   }
  } ;# proc UNSET
} ;# namespace tmp
